; EXTERNS

EXTERN DbgPrint:PROC

.DATA
cpusig BYTE 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

.CODE

_Cr4 PROC
	mov		rax, cr4
	ret
_Cr4 ENDP

_ReadMsr PROC
;	xor		rax, rax
	rdmsr				; MSR.index(ecx) -> edx:eax
	shl		rdx, 32
	or		rax, rdx
	ret
_ReadMsr ENDP

_MyCpuid PROC

	;; preserve all (overkill?) non-volatile regs
	push rbx
	push rbp
	push rdi
	push rsi
	push r12
	push r13
	push r14
	push r15

	xor eax, eax
	cpuid
	lea rax, cpusig
	mov [rax+0], ebx	
	mov [rax+4], edx
	mov [rax+8], ecx
	lea rax, cpusig
	

	pop r15
	pop r14
	pop r13
	pop r12
	pop rsi
	pop rdi
	pop rbp
	pop rbx

	ret

_MyCpuid ENDP



END